var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentMethod, MapToComponentField, VegaSlimmer } from 'vega-slimmer/core';
import { DomNodeSubjectObserverFactory } from '../../../../helpers/change-manager/subject/dom-node-subject/dom-node-subject-observer-factory';
import { VegaInternalPaginationCurrentChange } from '../../../../helpers/event-manager/event-id/vega-internal-event-id';
/** The `VegaPaginationCurrentPageObserverController` class is responsible for adding and removing observers for pagination current in Vega component. */
export class VegaPaginationCurrentPageObserverController extends VegaSlimmer {
  /**
   * Add the pagination current subject observer
   */
  registerPaginationCurrentChangeObserver() {
    DomNodeSubjectObserverFactory.addUniqueObserverToNode(this.host, VegaInternalPaginationCurrentChange, (payload) => {
      this.current = Number(payload.detail);
    });
  }
  /**
   * Remove the pagination current subject observer
   */
  unregisterPaginationCurrentChangeObserver() {
    DomNodeSubjectObserverFactory.removeUniqueObserverFromNode(this.host, VegaInternalPaginationCurrentChange);
  }
}
__decorate([
  MapToComponentField()
], VegaPaginationCurrentPageObserverController.prototype, "host", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaPaginationCurrentPageObserverController.prototype, "current", void 0);
__decorate([
  MapToComponentMethod('connectedCallback')
], VegaPaginationCurrentPageObserverController.prototype, "registerPaginationCurrentChangeObserver", null);
__decorate([
  MapToComponentMethod('disconnectedCallback')
], VegaPaginationCurrentPageObserverController.prototype, "unregisterPaginationCurrentChangeObserver", null);
